<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.3.0/css/all.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Import DataTable Library -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>

<body>
  <div class="container">
    <div class="text-center mt-2 mb-2">
      <h2>F100 - Customer Management</h2>
    </div>
    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3 text-right">
          <label>Role</label>
        </div>
        <div class="col-sm-6">
          <select id="select-role" class="form-control text-center">
            <option value="0">---choose a role---</option>
          </select>
        </div>
        <div class="col-sm-3">
          <button id="btn-filter-role" class="btn btn-info">Data Filter</button>
        </div>
      </div>
    </div>

    <div class="container">
      <table class="table table-bordered table-striped table-hover" id="user-table">
        <thead class="text-center">
          <tr>
            <th>STT</th>
            <th>Username</th>
            <th>Firstname</th>
            <th>Lastname</th>
            <th>Email</th>
            <th>Age</th>
            <th>Role</th>
            <th>Action</th>
          </tr>
        </thead>
      </table>
    </div>

</body>

<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // Mảng gUserObjects là mảng chứa dữ liệu users
  var gUserObjects = [
        {
          id: 2,
          username: "quannv",
          firstname: "Ngo Van",
          lastname: "Quan",
          age: 18,
          email: "quan@gmail.com",
          roleId: 5
        },
        {
          id: 3,
          username: "longdh",
          firstname: "Do Hoang",
          lastname: "Long",
          age: 19,
          email: "long@gmail.com",
          roleId: 8
        },
        {
          id: 4,
          username: "hiendt",
          firstname: "Do Thi",
          lastname: "Hien",
          age: 29,
          email: "hien@gmail.com",
          roleId: 11
        },
        {
          id: 6,
          username: "lanht",
          firstname: "Ho Thi",
          lastname: "Lan",
          age: 27,
          email: "lan@gmail.com",
          roleId: 13
        }
  ];
  // Mảng gRoleObjects là mảng chứa dữ liệu các roles
  var gRoleObjects = [
        {
          roleId: 5,
          roleName: "Admin" 
        },
        {
          roleId: 8,
          roleName: "Manager" 
        },
        {
          roleId: 11,
          roleName: "Teacher" 
        },
        {
          roleId: 13,
          roleName: "Staff" 
        }
  ];
  
  //set user's object
  const gUSER_COL = ['id', 'username', 'firstname', 'lastname', 'email', 'age', 'roleId', 'action'];

  //set columns for the user's table
  const gCOL_ID = 0;
  const gCOL_USERNAME = 1;
  const gCOL_FIRSTNAME = 2;
  const gCOL_LASTNAME = 3;
  const gCOL_EMAIL = 4;
  const gCOL_AGE = 5;
  const gCOL_ROLE_ID = 6;
  const gCOL_ACTION = 7;
  var gSTT = 0;

  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  $(document).ready(function(){

    onPageLoading();

    //add event for Filer Button
    $("#btn-filter-role").on('click', function(){
      btnFilterClick();
    })

    //add event for Dice History Button
    $("#user-table").on("click", ".dice-history", function(){
      btnDiceHistoryClick(this)
    })

  })
  


  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
  
  //function on loading data
  function onPageLoading(){

    var vUserTable = $("#user-table").DataTable({
      data: gUserObjects,
      columns: [
        {data: gUSER_COL[gCOL_ID]},
        {data: gUSER_COL[gCOL_USERNAME]},
        {data: gUSER_COL[gCOL_FIRSTNAME]},
        {data: gUSER_COL[gCOL_LASTNAME]},
        {data: gUSER_COL[gCOL_EMAIL]},
        {data: gUSER_COL[gCOL_AGE]},
        {data: gUSER_COL[gCOL_ROLE_ID]},
        {data: gUSER_COL[gCOL_ACTION]}
      ],
      columnDefs: [
        {
          targets: gCOL_ID,
          className: 'text-center',
          render: function (data, type, row, meta) {
                  return meta.row + meta.settings._iDisplayStart + 1;}
        },
        {
          targets: gCOL_AGE,
          className: 'text-center',
        },
        {
          targets: gCOL_ROLE_ID,
          render: renderRoleToTable
        },
        {
          targets: gCOL_ACTION,
          className: 'text-center',
          defaultContent: `
                  <i title="Dice history" class="fas fa-dice dice-history" style="color:red"></i> &nbsp;       
                  <i title="Voucher history" class="fas fa-gift voucher-history" style="color:green"></i>
                  `
        }
      ]
    });
    loadRoleToSelect();
  }

  //function on clicking Filter Button
  function btnFilterClick(){
    console.log("clicked");

    var vUserObj = new Object;

    //read the selected role id
    vUserObj.roleId = readSelectedRole()
      console.log(vUserObj.roleId)

    //find the user relevan to the filterred role
    var vFilterUser = findUserByRoleId(vUserObj.roleId)
      console.log(vFilterUser);

    //display the filter's result
    filterSeletedRole(vFilterUser)

  }

  //function of Dice History Button
  function btnDiceHistoryClick(paramHistory){
    
    var vRowParamHistory = rowIdClick(paramHistory);
    console.log("%cUSERNAME: ", "color:orange", vRowParamHistory);

    const vDICE_HISTORY = "task38.30 - Dice history.html"
    var vUrlToSideOpen = vDICE_HISTORY + "?" 
    + "username=" + vRowParamHistory.username
    + "&firstname=" + vRowParamHistory.firstname
    + "&lastname=" + vRowParamHistory.lastname;
    window.location.href = vUrlToSideOpen;
  

   
  }


  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  
  //function for loading role on the user's table
  function renderRoleToTable(paramRole){

    for (var index = 0; index < gRoleObjects.length; index++){
      if (paramRole == gRoleObjects[index].roleId){
        return gRoleObjects[index].roleName
      }
    }
  }

  //function on loading role to select filter
  function loadRoleToSelect(){
     
    for (var i=0; i<gRoleObjects.length; i++){
      var vOption = new Option(gRoleObjects[i].roleName);
      $("#select-role").append(vOption);
    }
  }

  //funtion on reading the selected role
  function readSelectedRole(paramRoleId){

    var vRoleName = $("#select-role").val();
    for (var i=0; i<gRoleObjects.length; i++){
      if (vRoleName.toLowerCase() === gRoleObjects[i].roleName.toLowerCase()){
        vRoleId = gRoleObjects[i].roleId;
      }
    }
    return vRoleId;
  }

  //function to find the user by roleId
  function findUserByRoleId(paramRoleId){
    var vFilterUser = [];

    vFilterUser = gUserObjects.filter(function(paramData){
      return (paramRoleId === paramData.roleId)
      });
    
    return vFilterUser;

  }

  //funtion on filter the seleted role
  function filterSeletedRole(paramData){
      
      $('#user-table').DataTable().clear(); 
      $('#user-table').DataTable().rows.add(paramData); 
      $('#user-table').DataTable().draw(); 

  }

  //function on getting id of the clicked row
  function rowIdClick(paramElement){
      var vRowClick = $(paramElement).parents('tr');
      var vTable = $("#user-table").DataTable();
      var DataRow = vTable.row(vRowClick).data();
     
      return DataRow
    }


</script>

</html>